%% Tests asso_with_mdl_int_par()'s scalability

% ten random matrices, each of size 300 x 100, density 20
fprintf('Creating data ...');
for i=1:10,
	M{i} = double(rand(300, 100) < 0.2);
end
fprintf(' done.\n');
% results: cols for different number of cores, rows for different matrices
time=nan(10, 4);
% extensive range for t
T=0.1:0.1:1;
% we do this matrix-by-matrix to avoid memory loading effects
for i=1:10;
	%fprintf('%i: ', i);
	for p=1:4,
		fprintf('%i: %i ', i, p);
		tic;
		asso_with_mdl_int_par(M{i}, T, 'processes', p, 'verbosity', 1);
		time(i, p) = toc;
	end
	fprintf('\n');
end

