function X = solve_x_greedy(A, C, wp);
% SOLVE_X_GREEDY - Solves X given A and C.
% X = SOLVE_X_GREEDY(A, C) returns Boolean X s.t. A ~ C o X.
% If C is a vector, it is assumed to contain the list of indices for A's
% columns. 
%
% X = SOLVE_X_GREEDY(A, idx, wp) values covered 1s by wp.

  if nargin == 2,
    wp = 1;
  end;

  if isvector(C),
    idx = C;
    m = length(idx);
    %C = A(:,idx);
  else,
    [foo,m] = size(C);
  end;
  M = zeros(size(A));
  X = [];
  
  if isvector(C),
    for i=1:m,
      [c, M, x] = cover(A, M, idx(i), wp);
      X(i,:) = x;
    end;
  else,
    for i=1:m,
      [c, M, x] = cover(A, M, C(:,i), wp);
      X(i,:) = x;
    end;
  end;
  
