function X = solve_x_greedy_matrix(A, C, wp);
% SOLVE_X_GREEDY_MATRIX - Solves X given A and C.
% X = SOLVE_X_GREEDY_MATRIX(A, C) returns Boolean X s.t. A ~ C o X.
% Unlike SOLVE_X_GREEDY, even if C is a vector, it is assumed to be a matrix.
%
% X = SOLVE_X_GREEDY(A, idx, wp) values covered 1s by wp.

  if nargin == 2,
    wp = 1;
  end;

  [foo,m] = size(C);
  M = zeros(size(A));
  X = [];
  
  for i=1:m,
    [c, M, x] = cover_matrix(A, M, C(:,i), wp);
    X(i,:) = x;
  end;
  
